
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>发表在 Science 上的一种新聚类算法 / 憋错料</title>

    <meta name="description" content="发表在 Science 上的一种新聚类算法 今年 6 月份,Alex Rodriguez 和 Alessandro Laio 在 Science 上发表了一篇名为&lt;Clustering by fast search and find of density peaks&gt;的文章,为聚类算法的设计提供了一种新的思路.虽然文章出来后遭到了众多读者的质疑,但整体而言,新聚类算法的基本思想很新颖,且简单明快,值得学习.这个新聚类算法的核心思想在于对聚类中心的刻画上,本文将对该算法的原理进行详细介绍,并对其中的若干细节展开讨论. 最后,附上 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">发表在 Science 上的一种新聚类算法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>    今年 6 月份，Alex Rodriguez 和 Alessandro Laio 在 Science 上发表了一篇名为《Clustering by fast search and find of density peaks》的文章，为聚类算法的设计提供了一种新的思路。虽然文章出来后遭到了众多读者的质疑，但整体而言，新聚类算法的基本思想很新颖，且简单明快，值得学习。这个新聚类算法的核心思想在于对聚类中心的刻画上，本文将对该算法的原理进行详细介绍，并对其中的若干细节展开讨论。</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAyMzUyOTg=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAyNDEyNTc=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAyNTI3MDg=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAzMDIzMTc=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAzMTA4NjY=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAwNDY0NTM=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAzMjY3NjM=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAzMzUyODA=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAxMTMzMTI=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAzNTA4NDk=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzA0MDIxNzU=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzA0MTE4NjI=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzA0MjAwOTk=.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzA0MjY2MDQ=.jpg" /></p>
<p>最后，附上作者在补充材料里提供的 Matlab&nbsp;示例程序&nbsp;（加了适当的代码注释）。</p>
<pre>clear all
close all
disp(‘The only input needed is a distance matrix file‘)
disp(‘The format of this file should be: ‘)
disp(‘Column 1: id of element i‘)
disp(‘Column 2: id of element j‘)
disp(‘Column 3: dist(i,j)‘)

%% 从文件中读取数据
mdist=input(‘name of the distance matrix file (with single quotes)?\n‘);
disp(‘Reading input distance matrix‘)
xx=load(mdist);
ND=max(xx(:,2));
NL=max(xx(:,1));
if (NL&gt;ND)
  ND=NL;  %% 确保 DN 取为第一二列最大值中的较大者，并将其作为数据点总数
end

N=size(xx,1); %% xx 第一个维度的长度，相当于文件的行数（即距离的总个数）

%% 初始化为零
for i=1:ND
  for j=1:ND
    dist(i,j)=0;
  end
end

%% 利用 xx 为 dist 数组赋值，注意输入只存了 0.5*DN(DN-1) 个值，这里将其补成了满矩阵
%% 这里不考虑对角线元素
for i=1:N
  ii=xx(i,1);
  jj=xx(i,2);
  dist(ii,jj)=xx(i,3);
  dist(jj,ii)=xx(i,3);
end

%% 确定 dc

percent=2.0;
fprintf(‘average percentage of neighbours (hard coded): %5.6f\n‘, percent);

position=round(N*percent/100); %% round 是一个四舍五入函数
sda=sort(xx(:,3)); %% 对所有距离值作升序排列
dc=sda(position);

%% 计算局部密度 rho (利用 Gaussian 核)

fprintf(‘Computing Rho with gaussian kernel of radius: %12.6f\n‘, dc);

%% 将每个数据点的 rho 值初始化为零
for i=1:ND
  rho(i)=0.;
end

% Gaussian kernel
for i=1:ND-1
  for j=i+1:ND
     rho(i)=rho(i)+exp(-(dist(i,j)/dc)*(dist(i,j)/dc));
     rho(j)=rho(j)+exp(-(dist(i,j)/dc)*(dist(i,j)/dc));
  end
end

% "Cut off" kernel
%for i=1:ND-1
%  for j=i+1:ND
%    if (dist(i,j)&lt;dc)
%       rho(i)=rho(i)+1.;
%       rho(j)=rho(j)+1.;
%    end
%  end
%end

%% 先求矩阵列最大值，再求最大值，最后得到所有距离值中的最大值
maxd=max(max(dist)); 

%% 将 rho 按降序排列，ordrho 保持序
[rho_sorted,ordrho]=sort(rho,‘descend‘);

%% 处理 rho 值最大的数据点
delta(ordrho(1))=-1.;
nneigh(ordrho(1))=0;

%% 生成 delta 和 nneigh 数组
for ii=2:ND
   delta(ordrho(ii))=maxd;
   for jj=1:ii-1
     if(dist(ordrho(ii),ordrho(jj))&lt;delta(ordrho(ii)))
        delta(ordrho(ii))=dist(ordrho(ii),ordrho(jj));
        nneigh(ordrho(ii))=ordrho(jj);
        %% 记录 rho 值更大的数据点中与 ordrho(ii) 距离最近的点的编号 ordrho(jj)
     end
   end
end

%% 生成 rho 值最大数据点的 delta 值
delta(ordrho(1))=max(delta(:));

%% 决策图

disp(‘Generated file:DECISION GRAPH‘)
disp(‘column 1:Density‘)
disp(‘column 2:Delta‘)

fid = fopen(‘DECISION_GRAPH‘, ‘w‘);
for i=1:ND
   fprintf(fid, ‘%6.2f %6.2f\n‘, rho(i),delta(i));
end

%% 选择一个围住类中心的矩形
disp(‘Select a rectangle enclosing cluster centers‘)

%% 每台计算机，句柄的根对象只有一个，就是屏幕，它的句柄总是 0
%% &gt;&gt; scrsz = get(0,‘ScreenSize‘)
%% scrsz =
%%            1           1        1280         800
%% 1280 和 800 就是你设置的计算机的分辨率，scrsz(4) 就是 800，scrsz(3) 就是 1280
scrsz = get(0,‘ScreenSize‘);

%% 人为指定一个位置，感觉就没有那么 auto 了 :-)
figure(‘Position‘,[6 72 scrsz(3)/4. scrsz(4)/1.3]);

%% ind 和 gamma 在后面并没有用到
for i=1:ND
  ind(i)=i;
  gamma(i)=rho(i)*delta(i);
end

%% 利用 rho 和 delta 画出一个所谓的&ldquo;决策图&rdquo;

subplot(2,1,1)
tt=plot(rho(:),delta(:),‘o‘,‘MarkerSize‘,5,‘MarkerFaceColor‘,‘k‘,‘MarkerEdgeColor‘,‘k‘);
title (‘Decision Graph‘,‘FontSize‘,15.0)
xlabel (‘\rho‘)
ylabel (‘\delta‘)

subplot(2,1,1)
rect = getrect(1);
%% getrect 从图中用鼠标截取一个矩形区域， rect 中存放的是
%% 矩形左下角的坐标 (x,y) 以及所截矩形的宽度和高度
rhomin=rect(1);
deltamin=rect(2); %% 作者承认这是个 error，已由 4 改为 2 了!

%% 初始化 cluster 个数
NCLUST=0;

%% cl 为归属标志数组，cl(i)=j 表示第 i 号数据点归属于第 j 个 cluster
%% 先统一将 cl 初始化为 -1
for i=1:ND
  cl(i)=-1;
end

%% 在矩形区域内统计数据点（即聚类中心）的个数
for i=1:ND
  if ( (rho(i)&gt;rhomin) &amp;&amp; (delta(i)&gt;deltamin))
     NCLUST=NCLUST+1;
     cl(i)=NCLUST; %% 第 i 号数据点属于第 NCLUST 个 cluster
     icl(NCLUST)=i;%% 逆映射,第 NCLUST 个 cluster 的中心为第 i 号数据点
  end
end

fprintf(‘NUMBER OF CLUSTERS: %i \n‘, NCLUST);

disp(‘Performing assignation‘)

%% 将其他数据点归类 (assignation)
for i=1:ND
  if (cl(ordrho(i))==-1)
    cl(ordrho(i))=cl(nneigh(ordrho(i)));
  end
end
%% 由于是按照 rho 值从大到小的顺序遍历,循环结束后, cl 应该都变成正的值了. 

%% 处理光晕点，halo这段代码应该移到 if (NCLUST&gt;1) 内去比较好吧
for i=1:ND
  halo(i)=cl(i);
end

if (NCLUST&gt;1)

  % 初始化数组 bord_rho 为 0,每个 cluster 定义一个 bord_rho 值
  for i=1:NCLUST
    bord_rho(i)=0.;
  end

  % 获取每一个 cluster 中平均密度的一个界 bord_rho
  for i=1:ND-1
    for j=i+1:ND
      %% 距离足够小但不属于同一个 cluster 的 i 和 j
      if ((cl(i)~=cl(j))&amp;&amp; (dist(i,j)&lt;=dc))
        rho_aver=(rho(i)+rho(j))/2.; %% 取 i,j 两点的平均局部密度
        if (rho_aver&gt;bord_rho(cl(i)))
          bord_rho(cl(i))=rho_aver;
        end
        if (rho_aver&gt;bord_rho(cl(j)))
          bord_rho(cl(j))=rho_aver;
        end
      end
    end
  end

  %% halo 值为 0 表示为 outlier
  for i=1:ND
    if (rho(i)&lt;bord_rho(cl(i)))
      halo(i)=0;
    end
  end

end

%% 逐一处理每个 cluster
for i=1:NCLUST
  nc=0; %% 用于累计当前 cluster 中数据点的个数
  nh=0; %% 用于累计当前 cluster 中核心数据点的个数
  for j=1:ND
    if (cl(j)==i)
      nc=nc+1;
    end
    if (halo(j)==i)
      nh=nh+1;
    end
  end

  fprintf(‘CLUSTER: %i CENTER: %i ELEMENTS: %i CORE: %i HALO: %i \n‘, i,icl(i),nc,nh,nc-nh);

end

cmap=colormap;
for i=1:NCLUST
   ic=int8((i*64.)/(NCLUST*1.));
   subplot(2,1,1)
   hold on
   plot(rho(icl(i)),delta(icl(i)),‘o‘,‘MarkerSize‘,8,‘MarkerFaceColor‘,cmap(ic,:),‘MarkerEdgeColor‘,cmap(ic,:));
end
subplot(2,1,2)
disp(‘Performing 2D nonclassical multidimensional scaling‘)
Y1 = mdscale(dist, 2, ‘criterion‘,‘metricstress‘);
plot(Y1(:,1),Y1(:,2),‘o‘,‘MarkerSize‘,2,‘MarkerFaceColor‘,‘k‘,‘MarkerEdgeColor‘,‘k‘);
title (‘2D Nonclassical multidimensional scaling‘,‘FontSize‘,15.0)
xlabel (‘X‘)
ylabel (‘Y‘)
for i=1:ND
 A(i,1)=0.;
 A(i,2)=0.;
end
for i=1:NCLUST
  nn=0;
  ic=int8((i*64.)/(NCLUST*1.));
  for j=1:ND
    if (halo(j)==i)
      nn=nn+1;
      A(nn,1)=Y1(j,1);
      A(nn,2)=Y1(j,2);
    end
  end
  hold on
  plot(A(1:nn,1),A(1:nn,2),‘o‘,‘MarkerSize‘,2,‘MarkerFaceColor‘,cmap(ic,:),‘MarkerEdgeColor‘,cmap(ic,:));
end

%for i=1:ND
%   if (halo(i)&gt;0)
%      ic=int8((halo(i)*64.)/(NCLUST*1.));
%      hold on
%      plot(Y1(i,1),Y1(i,2),‘o‘,‘MarkerSize‘,2,‘MarkerFaceColor‘,cmap(ic,:),‘MarkerEdgeColor‘,cmap(ic,:));
%   end
%end
faa = fopen(‘CLUSTER_ASSIGNATION‘, ‘w‘);
disp(‘Generated file:CLUSTER_ASSIGNATION‘)
disp(‘column 1:element id‘)
disp(‘column 2:cluster assignation without halo control‘)
disp(‘column 3:cluster assignation with halo control‘)
for i=1:ND
   fprintf(faa, ‘%i %i %i\n‘,i,cl(i),halo(i));
end</pre>
<p>本系列聚类算法的其他链接：</p>
<p>第一章 &nbsp;<a href="http://blog.csdn.net/itplus/article/details/10087581" rel="external nofollow noreferrer">引言</a></p>
<p>第二章 &nbsp;<a href="http://blog.csdn.net/itplus/article/details/10088101" rel="external nofollow noreferrer">预备知识</a></p>
<p>第三章 &nbsp;<a href="http://blog.csdn.net/itplus/article/details/10088283" rel="external nofollow noreferrer">直接聚类法</a></p>
<p>第四章 &nbsp;<a href="http://blog.csdn.net/itplus/article/details/10088429" rel="external nofollow noreferrer">K-means</a></p>
<p>第五章 &nbsp;<a href="http://blog.csdn.net/itplus/article/details/10088625" rel="external nofollow noreferrer">DBSCAN</a></p>
<p>第六章 &nbsp;<a href="http://blog.csdn.net/itplus/article/details/10089323" rel="external nofollow noreferrer">OPTICS</a></p>
<p>第七章&nbsp;<a href="http://blog.csdn.net/itplus/article/details/10322361" rel="external nofollow noreferrer">聚类分析的效果评测</a></p>
<p>第八章&nbsp;<a href="http://blog.csdn.net/itplus/article/details/10484553" rel="external nofollow noreferrer">数据尺度化问题</a><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA4MjkxNzAyMDIwOTM=.jpg" /></p>
<p>作者: peghoty</p>
<p>出处:&nbsp;<a href="http://blog.csdn.net/itplus/article/details/38926837" rel="external nofollow noreferrer">http://blog.csdn.net/itplus/article/details/38926837</a></p>
<p>欢迎转载/分享, 但请务必声明文章出处.</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 23:28:57 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>发表在 Science 上的一种新聚类算法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a7KLE4.html" rel="bookmark">一种新型聚类算法&lpar;Clustering by fast search and find of density peaksd&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在学习论文的时候发现了在science上发表的关于新型的基于密度的聚类算法 Kmean算法有很多不足的地方,比如k值的确定,初始结点选择,而且还不能检测费球面类别的数据分布,对于第二个问题,提出了Kmean++,而其他不足还没有解决,dbscan虽然可以对任意形状分布的进行聚类,但是必须指定一个密度阈值,从而去除低于此密度阈值的噪音点,这篇文章解决了这些不足. 本文提出的聚类算法的核心思想在于,对聚类中心的刻画上,而且认为聚类中心同时具有以下两种特点: 本身的密度大,即它被密度均不超过它的邻			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rnPql3.html" rel="bookmark">博客上的几种新职业介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看了很多博客,发现了一些共同点.我觉得可以把这些博主分类一下,形成几种新的职业. 我不是在嘲讽谁,真的. 超文本抄书匠 Hypertext Book Copier 工作描述 手打大师,大段抄录实体书.教材.资料内容,并发表在博客里,作为教程系列,或者记录系列,列出目录超链接,坚称&quot;为学习留下记录&quot;云云.与此同时,可恶的鼠标总是会自动在发表之前勾选发布至首页,大师本人也很无奈. 入职条件 有一块优质的键盘,打字速度快.一套纸质资料,素材必不可少,否则无法开展工作. 要点 在与大家分享的时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Qje6lM.html" rel="bookmark">Science上发表的超赞聚类算法（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者(Alex Rodriguez, Alessandro Laio)提出了一种很简洁优美的聚类算法, 可以识别各种形状的类簇, 并且其超参数很容易确定. 算法思想 该算法的假设是类簇的中心由一些局部密度比较低的点围绕, 并且这些点距离其他有高局部密度的点的距离都比较大. 首先定义两个值: 局部密度以及到高局部密度点的距离: 其中 是一个截断距离, 是一个超参数.?所以相当于距离点i的距离小于的点的个数. 由于该算法只对的相对值敏感, 所以对dc的选择比较鲁棒, 一种推荐做法是选择使得平均每个点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qozL9M.html" rel="bookmark">Zstandard：一种新的无损压缩算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Zstandard(缩写为Zstd)是一种新的无损压缩算法,旨在提供快速压缩,并实现高压缩比.它既不像LZMA和ZPAQ那样追求尽可能高的压缩比,也不像LZ4那样追求极致的压缩速度. 下面是一组基准测试数据: 压缩算法名称 压缩比 压缩速度(MB/s) 解压速度(MB/s) zlib 1.2.8 -6 3.099 18 275 Zstd 2.872 201 498 zlib 1.2.8 -1 2.73 58 250 LZ4 HC r127 2.72 26 1720 QuickLZ 1.5.1b6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kDg1b3.html" rel="bookmark">二十八、带给我们一种新的编码思路&mdash;&mdash;EFW框架CS系统开发中的MVC模式探讨</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				回&lt;[开源]EFW框架系列文章索引&gt;        EFW框架源代码下载V1.3:http://pan.baidu.com/s/1c0dADO0 EFW框架实例源代码下载:http://pan.baidu.com/s/1eQCc69G       前言:记得最初写出Winform版MVC的代码是在公司的一个产品中,产品有几个界面功能比较多,一个界面窗体的代码尽然有1万多行代码,让我们在维护这几个界面的时候非常的痛苦,你可能想可以把这个大的界面拆分成几个小的界面在集成在一起不就好了,但实际上这样			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35lv9K0.html" rel="bookmark">6：知识的领域和结构，一种新的奇思妙想的组合结合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.三个案例 案例1:幼儿的语言学习 可见现象: 1.听音学语言,只有声音--结果:学不会 2.听看学语言,声音和画面--结果:很容易学会 通过不断的倾听声音和观察的画面形成关联 案例2:PPT训练营 可见现象: 操作技巧很熟练,但是成品整体水平很差劲. 做好PPT的3个领域知识: 1.PPT操作技巧: 插入元素.母版.快捷键.动画 2.足够的审美知识: 空间结构.颜色搭配.元素设计 3.足够的逻辑能力 结构大纲.先后顺序.语言提炼 案例3:记忆数字 一样长度的数字,有些容易记忆有些却很难 20			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nP72j4.html" rel="bookmark">如何在CentOS&sol;RHEL上安装或升级新的内核版本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux内核版本 Linux内核版本分为主线.稳定和长期版本.(所有内核版本都可以在内核开发官方网站https://www.kernel.org上获取)目前我们看到最新的稳定内核版本为4.10.12. 主线版本代表整个Linux内核的一个树干,新的主线版本每2-3个月发布一次,所有的新功能及特性都将会包含主线版本中.稳定内核则是在主线版本中,被认为是&quot;稳定的&quot;得出.稳定内核的任何错误修复都将从主线树中返回,也就是主线内核出现的任何错误(包括之前的任何旧版本内核的错误和BUG)在得到修			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49LEpX3.html" rel="bookmark">5、三种新方法判断是否包含字符串&sol;repeat&lpar;&rpar;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				传统上,JavaScript只有indexOf方法,来判断一个字符串是否包含在另一个字符串中.ES6又提供了三种新的方法. includes();返回布尔值,表示是否找到了参数字符串: startsWith();返回布尔值,表示参数字符串是否出现在在源字符串的开头: endWith();返回布尔值,表示参数字符串是否出现在源字符串的结尾. var str = &quot;Hello world!&quot;; str.startsWith(&quot;Hello&quot;) // true str.en			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Yq2vO0.html" rel="bookmark">将dll文件注入到其他进程中的一种新方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.45it.com/windowszh/201212/33946.htm http://www.hx95.cn/Article/OS/201212/65095.html 我们知道将动态连接库注入到其他进程中有很多种方法.最常见的方法是使用钩子函数(Hook),但是这种方法主要有两个缺点:第一如果某个进程没有加载User32.dll,那么Hook DLL将永远也不会被加载.第二Hook DLL加载的时机问题,只有在进程发出User32调用的时候, Hook DLL才有可能被加载			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0e2wZ3.html" rel="bookmark" class="title">Wiresahrk抓包过滤技术</a>
					<div>
						一.抓包过滤器BPF语法(Berkeley Packet Filter)类型:host.net.port方向:src.dst协议:ether.ip.tcp.udp.http.ftp等逻辑运算符:&am ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQ5k73.html" rel="bookmark" class="title">oracle 数据泵  每天自动备份</a>
					<div>
						@echo off echo 删除10天前的备分文件和日志 forfiles /p &quot;e:\app\back&quot; /m *.dmp /d -5 /c &quot;cmd /c del ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYRj80.html" rel="bookmark" class="title">Java初始化顺序</a>
					<div>
						1.在类的内部,变量的定义的先后顺序决定了初始化顺序,即使变量定义散布于方法定义间,他们仍旧会在任何方法(包括构造器)被调用之前得到初始化 2.静态数据的初始化 class Bowl{ Bowl(in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wrJvN0.html" rel="bookmark" class="title">winform 五子棋 判断输赢</a>
					<div>
						新手上路,高手勿进! 利用数组,根据新旧数组值的不同,获取那个点是什么棋子: 说明: 棋盘:15*15; 定义4个全局变量: string[,] stroldlist = new string[15, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWrzQ0.html" rel="bookmark" class="title">iOS&period;UIKit&period;11&period;UIPickerView</a>
					<div>
						一.案例介绍:点击UIButton,将选中的省市信息显示在UILabel中,如图01,02 图01图02 二.案例步骤: 1.选择Simple View Aplication,取名cq.37.普通选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bylGYM.html" rel="bookmark" class="title">hdu 5451 Best Solver（矩阵快速幂&plus;循环节&rpar;</a>
					<div>
						题意: 已知,给你整数x,和一个素数M,求[y]%M 思路: 设 (5+2√6)n=Xn+Yn*√6 Xn+Yn*√6 =(Xn-1+Yn-1*√6)*(5+2√6) =&gt; 5*Xn-1 + 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7B583.html" rel="bookmark" class="title">OpenSCAD 建模：矿泉水瓶花洒</a>
					<div>
						下载地址:https://github.com/ZhangGaoxing/openscad-models/tree/master/Sprinkle 代码: module screw(r=15){ fo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5pqB3.html" rel="bookmark" class="title">JavaScript 之 动态加载JS代码或JS文件</a>
					<div>
						2.动态加载JS文件 &lt;script type=&quot;text/javascript&quot;&gt; function loadScript(url, callback) { var  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p5OqJM.html" rel="bookmark" class="title">C&num;比较字符串及字符串常用函数</a>
					<div>
						C#比较字符串及字符串常用函数示例2007年08月26日 星期日 下午 02:29用C#比较字符串有多种方法,如: 1. string.Compare(x,y);2. string.Equals(x, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38LaZy3.html" rel="bookmark" class="title">Linux内核TCP&sol;IP参数分析与调优</a>
					<div>
						转载于:http://www.itxuexiwang.com/a/liunxjishu/2016/0225/167.html?1456482565 如下图展示的是TCP的三个阶段.1,TCP三次握手. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vZVGg3.html" rel="bookmark" class="title">&lbrack;Java Web&rsqb;Struts2加起来&lpar;一个&rpar;</a>
					<div>
						Struts2环境配置 进口Struts2的需要jar包 在WEB-INF/classes(src)文件夹下创建struts.xml文件 在web.xml文件里加入Struts过滤器信息 经常使用配置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPW2Pn4.html" rel="bookmark" class="title">mac下mysqldump找不到命令</a>
					<div>
						之所以会出现MySQL或者mysqldump这样的命令找不到, 我们可以打开/usr/bin文件夹,发现bin目录中并没有mysql打头的UEF文件, 而在/usr/local/mysql/bin中可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JYa1D3.html" rel="bookmark" class="title">jquery 动态增加删除行</a>
					<div>
						最近写程序,碰巧有动态增加删除行,下面就记录一下 html就不写了,也没有什么,直接上核心了 新增行 function addRow(obj){ //获得table一共有多少行,方便追加的时候给序号赋 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPwPPD4.html" rel="bookmark" class="title">C&plus;&plus;笔记16之const的用法总结</a>
					<div>
						const主要是为了程序的健壮型,减少程序出错. 最基本的用法: [cpp] view plaincopy const int a=100; b的内容不变,b只能是100也就是声明一个int类型的常量 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPNLyM.html" rel="bookmark" class="title">什么事Java序列化，如何实现Java序列化</a>
					<div>
						Java 串行化技术可以使你将一个对象的状态写入一个Byte 流里,并且可以从其它地方把该Byte 流里的数据读出来,重新构造一个相同的对象.这种机制允许你将对象通过网络进行传播,并可以随时把对象持久 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZ2rg0.html" rel="bookmark" class="title">（四）新建Maven项目</a>
					<div>
						我们以简单的helloworld来作为入门的实例,有些人说掌握了helloworld你就掌握了这门技术的一半了,对于maven来说,你掌握helloworld,你可能还稀里糊涂的. 1.从maven模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7ypY3.html" rel="bookmark" class="title">不动产登记系统</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02wEdA3.html" rel="bookmark" class="title">Erlang-实现进程环</a>
					<div>
						M是消息传递数目,N进程数量,Msg是传递的消息 -module(exe3_2). -export([start/3,stop/0]). start(M,N,Msg) -&gt;register(ri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Op6wX4.html" rel="bookmark" class="title">bzoj 3170 Tjoi 2013 松鼠聚会 曼哈顿距离&amp;amp&semi;&amp;amp&semi;切比雪夫距离</a>
					<div>
						因为曼哈顿距离很好求,所以要把每个点的坐标转换一下. 转自:http://blog.csdn.net/slongle_amazing/article/details/50911504 题解 两个点的切 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QoeNw0.html" rel="bookmark" class="title">mave安装配置</a>
					<div>
						首先从官网上 http://maven.apache.org/ 下载最新版Maven.我用的是apache-maven-3.0.4-bin.tar.gz.将下载后的文件拷贝到 /usr/local/目 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
